<?php
/**
 * @version    1.0.2
 * @package    Joomla.Plugin
 * @subpackage Content.printfriendly
 * @copyright  Copyright (C) 2005 - 2017 PrintFriendly. All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgContentPrintfriendly extends JPlugin {
  private $pfScriptInserted = false;

  function onContentBeforeDisplay($context, &$article, &$params, $limitstart)
  {
    if (in_array('0', $this->params->get('button-place'))) {
      return $this->buttonInDivCode();
    }
  }

  function onContentAfterDisplay($context, &$article, &$params, $limitstart)
  {
    if (in_array('1', $this->params->get('button-place'))) {
      return $this->buttonInDivCode();
    }
  }

  function onContentPrepare($context, &$article, &$params, $limitstart)
  {
    if (in_array('2', $this->params->get('button-place'))) {
      $article->text = str_replace('[printfriendly]', $this->buttonCode(), $article->text);
    }
  }

  function buttonInDivCode()
  {
    $position = $this->params->get('button-position') == '0' ? 'left' : 'right';
    return '<div style="text-align: ' . $position . '">' . $this->buttonCode() . '</div>';
  }

  function buttonCode()
  {
    $this->insertPfScript();

    $cdn = 'https://cdn.printfriendly.com/';

    switch ($this->params->get('button-style')) {
        case '0':
            $img = $cdn . 'pf-button.gif';
            break;
        case '1':
            $img = $cdn . 'pf-button-both.gif';
            break;
        case '2':
            $img = $cdn . 'pf-button-big.gif';
            break;
        case '3':
            $img = $cdn . 'button-print-grnw20.png';
            break;
        case '4':
            $img = $cdn . 'button-print-blu20.png';
            break;
        case '5':
            $img = $cdn . 'button-print-gry20.png';
            break;
        case '6':
            $img = $this->params->get('button-custom-image');
            break;
    }

    $this->consoleLog($img);

    return '<a class="print-no" style="cursor: pointer" onclick="window.print();"><img style="border:none;-webkit-box-shadow:none; box-shadow:none;" src="' . $img . '" alt="Print Friendly"></a>';
  }

  function insertPfScript()
  {
    if (!$this->pfScriptInserted) {
      $this->pfScriptInserted = true;
      $document = JFactory::getDocument();
      $document->addScript('https://cdn.printfriendly.com/printfriendly.js');
    }
  }

  function consoleLog($data) {
    echo '<script> console.log(' . json_encode($data) . '); </script>';
  }
}
